new;
library optmum,pgraph;

#include copula.src;
#include gumbel.src;


__output = 0;

alpha = 1.75;
sv = 1.75;
Nr = 250;
theta = zeros(Nr,1);

Nobs = 100; 
{u1,u2} = rndGumbelCopula(Nobs,Nr,alpha);
i = 1;
do until i > Nr;
  {theta[i],stderr,Logl} = mleGumbelCopula(u1[.,i],u2[.,i],sv);
  i = i + 1;
endo;
{est1,dens1} = Kernel(theta,1,3,256);

Nobs = 200;
{u1,u2} = rndGumbelCopula(Nobs,Nr,alpha);
i = 1;
do until i > Nr;
  {theta[i],stderr,Logl} = mleGumbelCopula(u1[.,i],u2[.,i],sv);
  i = i + 1;
endo;
{est2,dens2} = Kernel(theta,1,3,256);

Nobs = 300;
{u1,u2} = rndGumbelCopula(Nobs,Nr,alpha);
i = 1;
do until i > Nr;
  {theta[i],stderr,Logl} = mleGumbelCopula(u1[.,i],u2[.,i],sv);
  i = i + 1;
endo;
{est3,dens3} = Kernel(theta,1,3,256);

graphset;
  _pframe = 0; _pdate = ""; _pnum = 2;
  _pltype = 6|1|3;
  xtics(1.25,2.25,0.25,2);
  ytics(0,5,1,2);
  xlabel("\202a\201[ML]");
  ylabel("PDF");
  _plegstr = "Nobs = 100\000Nobs = 200\000Nobs = 300";
  _plegctl = {2 5 6 3};
  graphprt("-c=1 -cf=gumbel1.ps");
  xy(est1~est2~est3,dens1~dens2~dens3);


proc (2) = Kernel(data,xmin,xmax,Nx);
  local N,s,h,x,d;

  N = rows(data);
  s = stdc(data);
  h = 1.364*s*(N^(-0.2));
  x = seqa(xmin,(xmax-xmin)/(Nx-1),Nx);
  d = meanc(pdfn((x'-data)/h)/h);

  retp(x,d);
endp;
